package com.cedarsoft.business.contact.communication;

import com.cedarsoft.business.contact.Classification;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 * Describes a communication channel (e.g. phone, mail...)
 */
public interface CommunicationChannel {
  @NonNls
  @NotNull
  String PROPERTY_REPRESENTATION = "representation";
  @NonNls
  @NotNull
  String PROPERTY_DESCRIPTION = "description";
  @NonNls
  @NotNull
  String PROPERTY_CLASSIFICATION = "classification";
  @NonNls
  @NotNull
  String PROPERTY_ACTIVE = "active";

  /**
   * Returns the classification
   *
   * @return the classification
   */
  @NotNull
  Classification getClassification();

  /**
   * Returns a string that represents the communication channel
   *
   * @return a string representation
   */
  @NotNull
  @NonNls
  String getRepresentation();

  @NotNull
  String getDescription();

  boolean isActive();

  void setActive( boolean active );

  /**
   * Returns the classification
   *
   * @param classification the classification
   */
  void setClassification( @NotNull Classification classification );
}
