package com.cedarsoft.business.contact.communication;

import com.cedarsoft.business.contact.Classification;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 *
 */
public class Email extends AbstractCommunicationChannel {

  private static final long serialVersionUID = -3842741432978369800L;
  @NonNls
  public static final String PROPERTY_MAIL = "mail";
  @NotNull
  @NonNls
  private String mail = "";

  /**
   * Hibernate constructor
   */
  @Deprecated
  protected Email() {
  }

  public Email( @NotNull @NonNls String mail ) {
    this.mail = mail;
  }

  public Email( @NotNull Classification classification, @NotNull @NonNls String mail ) {
    this( classification, mail, false );
  }

  public Email( @NotNull Classification classification, @NotNull @NonNls String mail, boolean active ) {
    super( classification, active );
    this.mail = mail;
  }

  @NotNull
  @NonNls
  public String getMail() {
    lock.readLock().lock();
    try {
      return mail;
    } finally {
      lock.readLock().unlock();
    }
  }

  public void setMail( @NotNull String mail ) {
    lock.writeLock().lock();
    try {
      pcs.firePropertyChange( PROPERTY_MAIL, this.mail, this.mail = mail );
    } finally {
      lock.writeLock().unlock();
    }
  }

  @NotNull
  @NonNls
  public String getRepresentation() {
    return getMail();
  }

  @Override
  public String toString() {
    return getMail();
  }
}
