package com.cedarsoft.business.contact.communication;

import com.cedarsoft.business.contact.Classification;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 *
 */
public class FaxNumber extends NumberBasedCommunicationChannel {
  /**
   * Hibernate
   */
  @Deprecated
  protected FaxNumber() {
    super( "", "", "" );
  }

  public FaxNumber( @NonNls @NotNull String countryCode, @NotNull @NonNls String areaCode, @NotNull @NonNls String number ) {
    super( countryCode, areaCode, number );
  }

  public FaxNumber( @NonNls @NotNull String countryCode, @NotNull @NonNls String areaCode, @NotNull @NonNls String number, Classification classification ) {
    super( countryCode, areaCode, number, classification );
  }

  @Override
  public String toString() {
    lock.readLock().lock();
    try {
      return "Fax: " + countryCode + ' ' + areaCode + ' ' + number;
    } finally {
      lock.readLock().unlock();
    }
  }
}
